(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: FNTEDIT.PAS                                                    *)
(*  Obsah: editor na rastrove fonty (*.FNT)                                *)
(*  Autor: Mircosoft                                                       *)
(*  Posledni uprava: 5.10.2007                                             *)
(*  Pro kompilaci: viz Uses                                                *)
(*  Pro spusteni: STDSIPKA.KUR, MSDFLT.FNT                                 *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

{dodelat:
- posun znaku
- import z PCX
- zesikmeni
- globalni zmena vysky
- protazeni?}

program Editor_na_fonty;
{$B-,I-,R-,S-,X-,D-,L-}
uses vesa,grafika3,mys3,woknows3,klavesy,konst,retezce,disk,cfg;

{format FNT souboru:

 vyska pisma (byte) = pocet radku jednoho znaku
 doporucena roztec (byte)
 doporucena velikost (byte) - dolni 4 bity urcuji velikostX, horni velikostY
 data (array[#0..#255,1..vyska] of byte)
}

const ycisla=240;
      yznaku=250;

var fn:_font;{aktualne upravovany font}
    krpole:array[0..29,0..7]of boolean;{kreslici pole}
    i,j:word;{pomocne indexy}
    vybrany:byte;{ordinalni cislo vybraneho znaku, ktery se prave upravuje}
    ttp:textovepole;{pro psani zkusebniho textu}
    vyska:byte;{vyska aktualniho fontu (totez jako fn.fvyska, jen pro kratsi zapis)}
    soubor:string[79];
    o:word;{pro klavesnici}

procedure nactiznak;{nacte znak Vybrany z fontu do Krpole a zobrazi ho}
var pom,x,y:byte;
Begin
for y:=0 to vyska-1 do
  begin
  pom:=fn.fdata^[vyska*vybrany+y];
  for x:=0 to 7 do krpole[y,x]:=((pom shr (7-x)) and 1)=1;
  end;
kvyp;
for i:=0 to vyska-1 do
 for j:=0 to 7 do _bar(j shl 4+1,i shl 4+1,j shl 4+15,i shl 4+15,ord(krpole[i,j])shl 1);
kzap;
End;{nactiznak}

procedure UlozZnak;{ulozi znak z KrPole do fontu a zobrazi ho}
var pom,x,y:byte;
Begin
for y:=0 to vyska-1 do
  begin
  for x:=0 to 7 do begin
                   pom:=pom shl 1;
                   pom:=pom or ord(krpole[y,x]);
                   end;
  fn.fdata^[vyska*vybrany+y]:=pom;
  end;
kvyp;
_bar(141+(vybrany and 15)*9,(vybrany shr 4)*(vyska+1)+1,{vymazani puvodniho znaku}
     140+(vybrany and 15)*9+8,(vybrany shr 4)*(vyska+1)+vyska,0);
_nastavfont(fn,false);
_nastavtext(1,1,0);
_print(141+(vybrany and 15)*9,(vybrany shr 4)*(vyska+1)+1,2,chr(vybrany));{napsani noveho}
kzap;
End;{ulozznak}

procedure VyberZnak(cislo:byte);
Begin
kvyp;
_rectangle(140+(vybrany and 15)*9,(vybrany shr 4)*(vyska+1),
           149+(vybrany and 15)*9,(vybrany shr 4)*(vyska+1)+vyska+1,8);
ulozznak;
vybrany:=cislo;
kvyp;
_rectangle(140+(vybrany and 15)*9,(vybrany shr 4)*(vyska+1),
           149+(vybrany and 15)*9,(vybrany shr 4)*(vyska+1)+vyska+1,15);
_nastavfont(wokfont,true);
napis(349,ycisla,10,0,nastr2(vybrany,3));
napis(507,yznaku,10,0,chr(vybrany));
_nastavfont(fn,true);
nactiznak;
End;{vyberznak}

procedure kreslisadu;{vykresli celou znakovou sadu}
var i:word;
Begin
kvyp;
_bar(140,0,284,479,0);{vymazani cele sady}
for i:=0 to 16 do begin{mrizka}
                  _hline(140,284,i*vyska+i,8);
                  _vline(140+i shl 3+i,0,vyska shl 4+16,8);
                  end;
_nastavfont(fn,false);
_nastavtext(1,1,0);
for i:=0 to 255 do _print(141+(i and 15)*9,(i shr 4)*(vyska+1)+1,2,chr(i));{znaky}
_nastavfont(fn,true);           {mod 16}     {div 16}
kzap;
End;{kreslisadu}

procedure load;
var jak:byte;
    posunuti:shortint;
    i,y,z:byte;
    vychozi:_font;
    vychozisoubor:string[79];
Begin
if soubor='' then begin
                  okokno('Nebylo zadno jmno souboru, nemu proto nic nast.|');
                  exit;
                  end;
if fn.fdata<>nil then freemem(fn.fdata,256*vyska);
_nactifont2(fn,soubor);
vyska:=fn.fvyska;
if fn.fdata=nil then begin
                     vyska:=vlozcislookno('Zadej vku psma [pix.]:',1,30,8);
                     fn.fvyska:=vyska;
                     getmem(fn.fdata,256*vyska);
                     fillchar(fn.fdata^,256*vyska,0);
                     vychozisoubor:=vybersouborokno('Zaloit na:','FNT','');
                     _nactifont2(vychozi,vychozisoubor);
                     if vychozi.fdata<>nil then
                       begin
                       posunuti:=vlozcislookno('odsazen od hornho okraje:',0,vyska-1,0);
                       for i:=0 to 255 do
                         begin
                         z:=0;
                         for y:=posunuti to vyska-1 do begin
                                                       fn.fdata^[i*vyska+y]:=vychozi.fdata^[i*vychozi.fvyska+z];
                                                       inc(z);
                                                       if z>=vychozi.fvyska then break;
                                                       end;
                         end;
                       _zrusfont(vychozi);
                       end;
                     fn.fstdx:=vlozcislookno('Jakou doporuujete Xovou velikost?',0,15,1);
                     fn.fstdy:=vlozcislookno('A jakou Yovou?',0,15,1);
                     fn.fstdroztec:=vlozcislookno('A co rozte?',0,255,8);
                     end;
kreslisadu;
nactiznak;
vyberznak(vybrany);
infokno(320,240,'Nateno.',true);
End;{load}

procedure save;
Begin
ulozznak;
_nastavfont(wokfont,true);
if _ulozfont(fn,soubor) then infokno(320,240,'Uloeno.',true)
                        else okokno('Chyba pi ukldn.');
_nastavfont(fn,true);
End;{save}

BEGIN
cfgsoubor:='FNTEDIT.CFG';
fn.fdata:=nil;
_frekvence:=75;
_setmode(_640x480); initmys; zapniobsluhumysi; initwoknows;
dialogystandardnimfontem:=true; nactinastavenimysi;
{soubor:}
if paramcount=0 then repeat
                     soubor:=vybersouborokno('','FNT','')
                     until soubor<>''
                else soubor:=paramstr(1);
load;
_nastavfont(wokfont,true);
kvyp;
{mrizka kresliciho pole (vysku nastavila procedura Load):}
for i:=0 to vyska do _hline(0,128,i shl 4,6);
for j:=0 to 8 do _vline(j shl 4,0,vyska shl 4,6);
{popisky:}
_print(290,10,7,'My:');
_print(290,20,7,'lev tlatko: v kreslicm poli vybarv bod,');
_print(410,30,7,'v tabulce znak vybere znak.');
_print(290,40,7,'prav tlatko: v kreslicm poli vymae bod,');
_print(370,50,7,'v tabulce znak vymae cel znak.');
_print(290,70,7,'Klvesnice:');
_print(290,80,7,lsipkazn+psipkazn+hsipkazn+dsipkazn+': vbr znaku');
_print(290,90,7,'Del: vymazn znaku');
_print(290,100,7,'F2: uloen');
_print(290,110,7,'F3: naten');
_print(290,120,7,'K: koprovn vybranho znaku');
_print(290,130,7,'U: uloen upravovanho znaku do tabulky');
_print(290,140,7,'R: penastaven parametr psma');
_print(290,150,7,'M: nastaven vlastnost myi');
_print(290,160,7,'Esc: konec');

_print(290,180,7,'soubor:');
_print(290,190,10,zkratcestu(soubor,40));

_print(290,200,7,'Parametry fontu:');
_print(290,210,7,'vka:'); _print(350,210,10,nastr(vyska));
_print(290,220,7,'rozte:'); _print(350,220,10,nastr(fn.fstdroztec));

_print(290,ycisla,7,'znak: %%b010#');
_print(290,yznaku,7,'systmovm fontem obvykle: ');

_rectangle(552,381,639,409,9);
_print(561,386,9,'Mircosoft');
_print(565,396,9,'FontEdit');

_nastavfont(fn,true); {takto je nastaven v celem hlavnim cyklu, na jine nastaveni se prepina jen chvilkove a zase se vraci sem}

ttp.init(1,470-_vyskatextu2,630 div fn.fstdroztec,'Toto je testovac pole pro vyzkouen upravovanho fontu.',false,false);
vyberznak(65);
 Repeat{hlavni cyklus}
 cekej;
 if ttp.stav<>_aktivni then
 if lmys then begin
              if mysvpoli(0,0,127,16*vyska-1) then
                begin{nakresleni bodu}
                i:=ymys shr 4;{y}
                j:=xmys shr 4;{x}
                krpole[i,j]:=true;
                kvyp;
                _bar(j shl 4+1,i shl 4+1,j shl 4+15,i shl 4+15,2);
                kzap;
                end
               else if mysvpoli(140,0,140+16*9-1,(vyska+1)shl 4-1) then
                      begin{vyber znaku}
                      vyberznak(((ymys div(vyska+1)) shl 4)+((xmys-140) div 9));
                      resetuj;
                      end;
              end
  else if pmys then begin
                    if mysvpoli(0,0,127,16*vyska-1) then
                      begin{smazani bodu}
                      i:=ymys shr 4;
                      j:=xmys shr 4;
                      krpole[i,j]:=false;
                      kvyp;
                      _bar(j shl 4+1,i shl 4+1,j shl 4+15,i shl 4+15,0);
                      kzap;
                      end
                     else if mysvpoli(129,0,139,479)then resetuj{abych omylem nesmazal znak,
                                        kdyz mi pri mazani bodu vyjede kurzor z kreslici plochy.
                                                    Moc to sice nepomaha, ale aspon neco.}
                      else if mysvpoli(140,0,140+16*9-1,(vyska+1)shl 4-1) then
                             begin{smazani znaku}
                             i:=((ymys div(vyska+1)) shl 4)+((xmys-140) div 9);
                             vyberznak(i);
                             if anoneokno('Opravdu chcete znak '''+chr(vybrany)+''' vymazat?') then
                              begin
                              fillchar(fn.fdata^[vyska*vybrany],vyska,0);{for i:=0 to vyska-1do fn.fdata^[vyska*vybrany+i]:=0;}
                              nactiznak;
                              kvyp;
                              _bar(141+(vybrany and 15)*9,(vybrany shr 4)*(vyska+1)+1,
                                   140+(vybrany and 15)*9+8,(vybrany shr 4)*(vyska+1)+vyska,0);
                              kzap;
                              end;
                             resetuj;
                             end;
                    end
   else if keypressed then begin
                           o:=xreadkey;
                           case o of
                            xlsipka:if vybrany>0 then vyberznak(vybrany-1);
                            xpsipka:if vybrany<255 then vyberznak(vybrany+1);
                            xhsipka:if vybrany shr 4>0 then vyberznak(vybrany-16);
                            xdsipka:if vybrany shr 4<15 then vyberznak(vybrany+16);
                            xdel:if anoneokno('Opravdu chcete znak '''+chr(vybrany)+''' vymazat?') then
                                   begin
                                   fillchar(fn.fdata^[vyska*vybrany],vyska,0);
                                   nactiznak;
                                   kvyp;
                                   _bar(141+(vybrany and 15)*9,(vybrany shr 4)*(vyska+1)+1,
                                        140+(vybrany and 15)*9+8,(vybrany shr 4)*(vyska+1)+vyska,0);
                                   kzap;
                                   end;
                            xF2:save;
                            xF3:begin
                                kvyp;
                                _bar(0,470-_vyskatextu2,639,479,0);
                                load;
                                ttp.init(1,470-_vyskatextu2,630 div fn.fstdroztec,ttp.hodnota,false,false);
                                end;
                            ord('k'),ord('K'):begin{kopie vybraneho znaku nekam}
                                              ulozznak;
                                              resetuj;
                                              _nastavfont(wokfont,true);
                                              infokno(390,50,lsipkazn+' Vyber clovou pozici.',ne);
                                              _nastavfont(fn,true);
                                              _nastavtext(1,1,0);
                                              if mysvpoli(140,0,140+16*9-1,(vyska+1)shl 4) then
                                                begin
                                                i:=((ymys div(vyska+1)) shl 4)+((xmys-140) div 9);
                                                for j:=0 to vyska-1 do fn.fdata^[vyska*i+j]:=fn.fdata^[vyska*vybrany+j];
                                                kvyp;
                                                _bar(141+(i and 15)*9,(i shr 4)*(vyska+1)+1,
                                                     140+(i and 15)*9+8,(i shr 4)*(vyska+1)+vyska,0);
                                                _print(141+(i and 15)*9,(i shr 4)*(vyska+1)+1,2,chr(i));
                                                vyberznak(i);
                                                end;
                                              resetuj;
                                              end;
                            ord('u'),ord('U'):begin
                                              ulozznak;{aktualizace znaku v sade}
                                              _nastavfont(fn,true);
                                              end;
                            ord('r'),ord('R'):begin{nastaveni standardnich rozmeru}
                                              fn.fstdx:=vlozcislookno('Xov velikost:',1,15,fn.fstdx);
                                              fn.fstdy:=vlozcislookno('Yov velikost:',1,15,fn.fstdy);
                                              fn.fstdroztec:=vlozcislookno('rozte:',0,255,fn.fstdroztec);
                                              _nastavfont(wokfont,true);
                                              kvyp;
                                              napis(350,220,10,0,nastr(fn.fstdroztec)+'  ');
                                              _nastavfont(fn,true);
                                              _bar(0,470-_vyskatextu2,639,479,0);
                                              ttp.init(1,470-_vyskatextu2,630 div fn.fstdroztec,ttp.hodnota,false,false);
                                              end;
                            ord('m'),ord('M'):nastavmysokno(true);
                           end;{case}
                           end;
 ttp.kontrola;
 if ttp.stav=_aktivni then resetuj;
 Until o=27;{konec hlavniho cyklu}
_zrusfont(fn);
zrusobsluhumysi;
zruswoknows;
_setmode(_textak);
END.